package cn.com.qmth.examcloud.task.service.consumer;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import cn.com.qmth.examcloud.task.base.multithread.Consumer;
import cn.com.qmth.examcloud.task.dao.entity.ReportsComputeEntity;
import cn.com.qmth.examcloud.task.service.ReportsComputeService;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

public class ReportsComputeConsumer extends Consumer<ReportsComputeEntity> {

	private static final Logger logger = LoggerFactory.getLogger(ReportsComputeConsumer.class);
	private ReportsComputeService reportsComputeService = SpringContextHolder.getBean(ReportsComputeService.class);

	@Override
	public void consume(ReportsComputeEntity et) {
		logger.info("***************************报表计算开始,projectId:"+et.getProjectId());
		// 修改报表计算任务状态
		reportsComputeService.updateToComputing(et);
		try {
			//计算报表
			reportsComputeService.compute(et);
		} catch (Exception e) {
			//计算出错
			reportsComputeService.updateToFail(et);
			logger.info("***************************报表计算出错,projectId:"+et.getProjectId());
		}
		logger.info("***************************报表计算结束,projectId:"+et.getProjectId());
	}
}
