package cn.com.qmth.examcloud.task.service.impl;

import java.util.Date;
import java.util.List;

import javax.transaction.Transactional;

import org.examcloud.core.reports.api.ProjectCloudService;
import org.examcloud.core.reports.api.request.UpdateProjectStatusReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.task.dao.ReportsComputeRepo;
import cn.com.qmth.examcloud.task.dao.entity.ReportsComputeEntity;
import cn.com.qmth.examcloud.task.dao.enums.ReportsComputeStatus;
import cn.com.qmth.examcloud.task.service.ReportsComputeService;

@Service
public class ReportsComputeServiceImpl implements ReportsComputeService {

	@Autowired
	private ReportsComputeRepo reportsComputeRepo;
	
	@Autowired
	private ProjectCloudService projectCloudService;

	@Override
	public List<ReportsComputeEntity> findTodoData(Long startId, Integer limit) {
		return reportsComputeRepo.findTodoData(startId, limit);
	}

	@Transactional
	@Override
	public void update(ReportsComputeEntity et) {
		reportsComputeRepo.save(et);
	}

	@Transactional
	@Override
	public void compute(ReportsComputeEntity et) {
		// TODO Auto-generated method stub
		
	}
	@Transactional
	@Override
	public void updateToComputing(ReportsComputeEntity et) {
		et.setStatus(ReportsComputeStatus.COMPUTING);
		et.setStartTime(new Date());
		reportsComputeRepo.save(et);
		UpdateProjectStatusReq req=new UpdateProjectStatusReq();
		req.setProjectId(et.getId());
		req.setStatus(2);
		projectCloudService.updateProjectStatus(req);
	}
	@Transactional
	@Override
	public void updateToSuccess(ReportsComputeEntity et) {
		et.setStatus(ReportsComputeStatus.SUCCESS);
		et.setEndTime(new Date());
		reportsComputeRepo.save(et);
		UpdateProjectStatusReq req=new UpdateProjectStatusReq();
		req.setProjectId(et.getId());
		req.setStatus(3);
		projectCloudService.updateProjectStatus(req);
	}
	@Transactional
	@Override
	public void updateToFail(ReportsComputeEntity et) {
		et.setStatus(ReportsComputeStatus.FAIL);
		et.setErrorDesc("系统错误");
		et.setEndTime(new Date());
		reportsComputeRepo.save(et);
		UpdateProjectStatusReq req=new UpdateProjectStatusReq();
		req.setProjectId(et.getId());
		req.setStatus(4);
		projectCloudService.updateProjectStatus(req);
	}
	@Transactional
	@Override
	public void updateToStoping(ReportsComputeEntity et) {
		et.setStatus(ReportsComputeStatus.STOPING);
		reportsComputeRepo.save(et);
	}
	@Transactional
	@Override
	public void updateToStop(ReportsComputeEntity et) {
		et.setStatus(ReportsComputeStatus.STOP);
		et.setEndTime(new Date());
		reportsComputeRepo.save(et);
		UpdateProjectStatusReq req=new UpdateProjectStatusReq();
		req.setProjectId(et.getId());
		req.setStatus(5);
		projectCloudService.updateProjectStatus(req);
	}



}
